/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Miscellaneous file-manipulation routines                               *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include <time.h>
#include "prog.h"
#include "max.h"
#include "max_msg.h"

long pascal Index_of_Area(int an)
{
  struct _aidx aidx[NUM_AIDX];

  int x,y;

  lseek(areasidx,0L,SEEK_SET);

  for (x=1;x != 0;)
  {
    x=read(areasidx,(char *)aidx,sizeof(struct _aidx)*NUM_AIDX)/sizeof(struct _aidx);

    for (y=0;y < x;y++)
    {
      if (aidx[y].area==an)
      {
        /* Seek back to put the file pointer in the right place... */

        lseek(areasidx,-(long)(x-y)*sizeof(struct _aidx),SEEK_CUR);
        return aidx[y].offset;
      }
    }
  }

  return -1;
}



/* Reads the AREAS.DAT entry for area `area' */

int pascal Read_Area(struct _area *area,int an)
{
  long off;

  if ((off=Index_of_Area(an))==-1)
    return -1;

  lseek(areasfile,off,SEEK_SET);
  read(areasfile,(char *)area,sizeof(struct _area));

  Fix_Area(area);

  return 0;
}




/* Writes the LASTUSxx.BBS file to the right directory. */

void pascal Write_LastUser(void)
{
  char temp[PATHLEN];
  struct _usr user;
  int file;

  /* Do a bit of manipulation of the _usr part of the LASTUSER file */

  user=usr;

  user.timeremaining=timeleft();
  user.time += timeonline();/* Temporarily add on time during this call    *
                             * (Normally, usr.time contains the time of    *
                             * all previous calls made today.)             */

  /* If we have to stay compatible with Opus, use 9600 for the local  *
   * baud rate!                                                       */

  if (local)
    user.flag=(prm.flags & FLAG_lbaud96) ? 9600 : 0;
  else user.flag=(unsigned int)baud;

  sprintf(temp,task_num ? lastusxx_bbs : lastuser_bbs,original_path,task_num);

  file=sopen(temp,O_CREAT | O_TRUNC | O_WRONLY | O_BINARY,SH_DENYWR,S_IREAD | S_IWRITE);

  if (file==-1)
    logit(cantopen,fancy_str(temp));
  else
  {
    write(file,(char *)&user,sizeof(struct _usr));
    close(file);
  }
}

